diff --git a/dwm.c b/dwm.c
index ffc8864..1d04e19 100644
--- a/dwm.c
+++ b/dwm.c
@@ -90,7 +90,7 @@ struct Client {
 	int oldx, oldy, oldw, oldh;
 	int basew, baseh, incw, inch, maxw, maxh, minw, minh;
 	int bw, oldbw;
-	unsigned int tags;
+	int tags;
 	Bool isfixed, isfloating, isurgent, neverfocus, oldstate, isfullscreen;
 	Client *next;
 	Client *snext;
@@ -135,7 +135,7 @@ typedef struct {
 	const char *class;
 	const char *instance;
 	const char *title;
-	unsigned int tags;
+	int tags;
 	Bool isfloating;
 	int monitor;
 } Rule;
@@ -295,7 +295,27 @@ applyrules(Client *c) {
 		&& (!r->instance || strstr(instance, r->instance)))
 		{
 			c->isfloating = r->isfloating;
-			c->tags |= r->tags;
+
+			if( r->tags == -1 ) {
+				unsigned int j, occ = 0;
+				Client *d;
+
+				for( d = selmon->clients; d; d = d->next ) {
+					occ |= d->tags;
+				}
+
+				for( j = 0; j < LENGTH( tags ); j++ ) {
+					if( ( occ & ( 1 << j ) ) == 0 ) {
+						c->tags = 1 << j;
+
+						break;
+					}
+				}
+			}
+			else {
+				c->tags |= r->tags;
+			}
+
 			for(m = mons; m && m->num != r->monitor; m = m->next);
 			if(m)
 				c->mon = m;
